q = 1.60217e-19;  %electron charge coulombs
h= 6.626e-34; % planks constant joules seconds
c = 3*10^8;  %speed of light
lambdar = 1064*10^-9;  %wavelength red light
lambdag = 532e-9; %wavelength green
kr = 2*pi/lambdar;    %wavenumber red
kg = 2*pi/lambdag;   %wavenumber of green


%photodetector parameters
%etaQEg = .95;     %quantum efficency for green PDs
Eg = (q*lambdag)/(h*c);      %responsivity to green
%etaQEr = 1;     %quantum efficency red PD
Er = .858;    %responsivity red PD (A/W)

%S0
Z0 = 40e3; % PD transimpedence ohms S0
PPSL = 1e-3; %power from PSL
etaQE0 = .95;
Pmain = 500e-3; %power from main laser W
etaMain0 = .002;  % attenuation factor for main beam at S0
etaPSL0 = .5;  %attenuation factor for PSL light

%Loop zero parameters not in electronics 
alpha02 = 15e-3;  %rad/V  pockels cell modulation index
alpha01 = 300e3; % Hz/V  PZT response

%Loop zero FSS parameters (electronic)(locking main laser to PSL)
g0 = .022; %overall gain 
g01 = 32e3; %fast path gain (added fudge factor)
g02 = 240; % pockels cell gain
f0z1 = 0 ;   %electronic zeros Hz
f0z2 = 77.6e3;
f0z3 = (97.5+i*205)*10^3;
f0z4 = (97.5-i*205)*10^3;
f0z5 = 1e8;
f0p1 = 1e3  ; %electronic poles
f0p2 = 2.13e3;
f0p3 = 3.1e3;
f0p4 = 150e3;
f0p5 = 100e3;
f0p6 = 10e3;
f0p7 = 23e3;
f0p8 = .01e3;

%Loop one actuators (locking aux to main laser)
alpha12 = 15e-3;  %rad/V  pockels cell modulation index
alpha11 = 300e3; % Hz/V  PZT response

%S1
Z1 = 40e3; % PD transimpedence ohms
Paux = 50e-3; %power from aux laser
etaQE1= .95;
etaMain1 = .002;  % attenuation factor for main laser
etaAux1 = .01;

g1 = .022; %overall gain 
g11 = 32e3; %fast path gain 
g12 = 240; % pockels cell gain
f1z1 = 0 ;   %electronic zeros Hz
f1z2 = 77.6e3;
f1z3 = (97.5+i*205)*10^3;
f1z4 = (97.5-i*205)*10^3;
f1z5 = 1e8;
f1p1 = 1e3  ; %electronic poles
f1p2 = 2.13e3;
f1p3 = 3.1e3;
f1p4 = 150e3;
f1p5 = 100e3;
f1p6 = 10e3;
f1p7 = 23e3;
f1p8 = .01e3;

%OPO optical parameters

Pog = 1; %incident power green on OPO
Rog1 = .7; %input coupler reflectivity green opo
Rog2 = 1; % other green mirror reflectivities in OPO (nicolai's loss)
Ror1 = .99; %red input coupler reflectivity
Ror2 = .85;  %red output coupler refl
Lo = .14;  % half of cavity length in meters
GOM = .01;  %modulation depth opo
fmo = 71*10^6 ;  %modulation frequency in hertz opo
%%%deltaog = 0.0001; %intracavity loss opo green(not used for now, not correct)
Pgreen = 1;
%derived quantities for OPO

rog1 = sqrt(Rog1); %amplitude reflectivities
rog2 = sqrt(Rog2);
ror1 = sqrt(Ror1);
ror2 = sqrt(Ror2);
tor1 = sqrt(1-Ror1);
tor2 = sqrt(1-Ror2);
tog1 = sqrt(1-Rog1);
tog2 = sqrt(1-Rog2);
Fog = pi*sqrt(rog1*rog2)/(1-rog1*rog2); %finesse green
Finored = pi*sqrt(ror1*ror2)/(1-ror1*ror2);   %finesse red
tog1 = sqrt(1-Rog1); %green input mirror transmission (amplitude)
wmo = 2*pi*fmo; %modulation freq in radians
foFSR= c/(2*Lo);  %OPO FSR
fog = foFSR/(2*Fog);  %green cavity pole
fored = foFSR/(2*Finored);  %red cavity pole

%coherent locking params
offset = 29.507e6;  %faux offset

%derived coherent locking params
phi = 2*pi*offset/foFSR; %phi phase shift from resonance
%%kaux = (2*pi/c)*(offset+c/lambdar);
%%kaux2 = (2*pi/c)*((c/lambdar)-offset);

%Loop 3  

%S3  
etaAux3 = .01;   %attenuation factor in Aux path to S3
etaLO3 = .01;  %attenuation factor in LO to S3
etaQE3 = .95;  %quantum efficency of PD3
PCD =100e-3; %contrast defect power after OMC
Z3 = 10^4; %transimpedance gain
f3 = 5*10^6; %pole of resonant detector
PLO = 10e-3;  %Power in LO
etatransaux = abs(tor1*tor2/(exp(i*phi)-ror1*ror2));
a = .33;
etaoportPgreen = etatransaux*(1-a)*((1-2*ror1*ror2*cos(phi)+(ror1*ror2)^2)*(1-rog1*rog2))/((1+a)*tor1*tor2*tog1);
etatransaux2 = etaoportPgreen*(tor1*tor2*tog1)/((1-2*ror1*ror2*cos(phi)+(ror1*ror2)^2)*(1-rog1*rog2));

etaaux3 = .01;
etaLO = .01;
%a = (etatransaux-etatransaux2)/(etatransaux+etatransaux2);  %feild amplitude assymetry
a = .33;

%G3
g30 = 1e5;  %common gain (TBD)
g31 = 1e6;  %PZT gain
g32 = 10^(17/20);    %servo additiveoffset gain
f3z1 = 20e3;  %zeros and poles in common path
f3z2 = 20e3;
f3p1 = 1e3;
f3p2 = 1e3;
f3p3 = 40;
f3p4 = 10;  %pole in PZT path
f3z3 = 0;  %in additive offset path (actualy in simulink as a time derivative)
f3z4 = 0;
f3p5 = 5;  %common path
f3p6 = 5;  %PZT path

%Actuators for loop 3
alpha31 = 5e-9;     %pzt in green path meters per volt
alpha32 = 1;        %additive offset gain

%S2  (OPO Relf coherent beam PD)
etaQE2 = .95;   %quantum efficency of S2
eta2 = .01;      %attenuation factor in path to S2
etaREFLaux = abs((ror2-ror1*exp(i*phi))/(exp(i*phi)-ror1*ror2));
etaREFLaux2 = etaoportPgreen*(ror2*(tor1^2)*tog1)/((1-2*ror1*ror2*cos(phi)+(ror1*ror2)^2)*(1-rog1*rog2));
etaREFL = etaREFLaux*etaREFLaux2;
Z2 = 1e3;      %transimpedance gain
f2 = 10*10^6;   %pole of resonant detector

%G2
g20 = 3.2e5;  %common gain
g21 = 1e6;  %PZT gain
g22 = 10^(17/20);    %servo additiveoffset gain
f2z1 = 20e3;  %zeros and poles in common path
f2z2 = 20e3;
f2p1 = 1e3;
f2p2 = 1e3;
f2p3 = 40;
f2p4 = 10;  %pole in PZT path
f2z3 = 0;  %in additive offset path 
f2z4 = 0;
f2p5 = 5;  %common path
f2p6 = 5;  %PZT path

%Actuators for loop 2
a21 = 5e-9;     %pzt in f aux loop meters per volt
a22 = 1;  %aux laser additive offset


%SHG optical parameters
RSR1 = .9; %input coupler reflectivity
RSR2 = .9992;  %back mirror reflectivity
Ls = .0947/2;  % one way cavity length in meters
ls = .05475;  %effective length
GSM = .01;  %modulation depth
fsm = 35.5*10^6 ;  %modulation frequency in hertz
deltaSR = .05; %red power loss

%derived optical params for SHG

rSR1 = sqrt(RSR1);
rSR2 = sqrt(RSR2);
Fsr = pi*sqrt(rSR1*rSR2*sqrt(1-deltaSR))/(1-rSR1*rSR2*sqrt(1-deltaSR)); %finesse of SHG for red
tSR1 = sqrt(1-RSR1); %first mirror transmission (amplitude)
wsm = 2*pi*fsm; %modulation freq in radians
fsFSR= c/(2*ls);  %free spectral range of SHG
fsr = fsFSR/(2*Fsr); %cavity linewidth
fbarsr = fsr/(rSR1*rSR2*sqrt(1-deltaSR));  

%S4  (SHG PD)
etaQE4 = .95;
Z4 = 10^4; %transimpedance gain
f4 = 5*10^6;  
eta4=.2;

%G4  (SHG compensation)
g4 = -10^(7.5);     %gain G4
f4z1 = 500;             %zero G4
f4p1 = 1;               %first pole G4
f4p2 = 1;               %second pole G4

%A4 (SHG length PZT)
alpha4 = 5e-9;

%S5  (OPO refl PD)
Z5 = 10^4; %transimpedance gain
f5 = 5*10^6; %pole
eta5 =.002;
etaQE5 = .95;

%G5  (OPO length compensation)
g5 = -1e7;      %gain G5
f5z1 = 500;      %zero G5
f5p1 = 1;       %first pole G5
f5p2 = 1;       %second pole G5

%A5 (OPO length PZT)
alpha5 = 5e-9;

%transfer functions of interferomter

MCp = 4e3; %frequency of mode cleaner pole
DCp = 1; %double cavity pole

eval('derivedquantites')
